%{?scl:%scl_package rubygem-%{gem_name}}
%{!?scl:%global pkg_name %{name}}

%global gem_name therubyracer

%global majorver 0.11.0
%global release 5
#%%global preminorver beta5
%global fullver %{majorver}%{?preminorver}

%{?preminorver:%global gem_instdir %{gem_dir}/gems/%{gem_name}-%{fullver}}
%{?preminorver:%global gem_extdir %{_libdir}/gems/exts/%{gem_name}-%{fullver}}
%{?preminorver:%global gem_docdir %{gem_dir}/doc/%{gem_name}-%{fullver}}
%{?preminorver:%global gem_spec %{gem_dir}/specifications/%{gem_name}-%{fullver}.gemspec}
%{?preminorver:%global gem_cache %{gem_dir}/cache/%{gem_name}-%{fullver}.gem}

Summary: Embed the V8 Javascript interpreter into Ruby
Name: %{?scl_prefix}rubygem-%{gem_name}
Version: %{majorver}
Release: %{?preminorver:0.}%{release}%{?preminorver:.%{preminorver}}%{?dist}
Group: Development/Languages
License: MIT
URL: http://github.com/cowboyd/therubyracer
Source0: http://rubygems.org/gems/%{gem_name}-%{version}%{?preminorver}.gem
# TODO: move these macros somewhere else?
# V8 versions macros
Source1: macros.therubyracer

# Include the constants defined in macros files.
%{lua:
function source_macros(file)
  local macro = nil

  for line in io.lines(file) do
    if not macro and line:match("^%%") then
      macro = line:match("^%%(.*)$")
      line = nil
    end

    if macro then
      if line and macro:match("^.-%s*\\%s*$") then
        macro = macro .. '\n' .. line
      end

      if not macro:match("^.-%s*\\%s*$") then
        rpm.define(macro)
        macro = nil
      end
    end
  end
end
source_macros(rpm.expand("%{SOURCE1}"))
}

Patch0: rubygem-therubyracer-0.11.0beta5-v8-3.14.5.8-compatibility.patch
#Patch0: %{pkg_name}-0.11.1-fix-bignum-conversion.patch
Requires: cfme-gemset
Requires: %{?scl_prefix}ruby(release)
Requires: %{?scl_prefix}ruby(rubygems)
Requires: %{?scl_prefix}ruby
Requires: %{?scl_prefix_v8}v8
BuildRequires: %{?scl_prefix}ruby(release)
BuildRequires: cfme-gemset
BuildRequires: %{?scl_prefix}rubygems-devel
BuildRequires: %{?scl_prefix}ruby-devel
BuildRequires: %{?scl_prefix_v8}v8-devel

# some specs run "ps aux"
BuildRequires: procps
Provides: %{?scl_prefix}rubygem(%{gem_name}) = %{version}
# same as in v8
ExclusiveArch:  %{ix86} x86_64 %{arm}

%description
Call javascript code and manipulate javascript objects from ruby. Call ruby
code and manipulate ruby objects from javascript.


%package doc
Summary: Documentation for %{pkg_name}
Group: Documentation
Requires: %{?scl_prefix}%{pkg_name} = %{version}-%{release}
BuildArch: noarch

%description doc
Documentation for %{pkg_name}

%prep
%{?scl:scl enable %{scl} - << \EOF}
gem unpack %{SOURCE0}
gem spec %{SOURCE0} -l --ruby > %{gem_name}.gemspec

%setup -n %{gem_name}-%{version}%{?preminorver} -q -D -T

%patch0 -p1

# Link v8 .so directly for now
%if 0%{?scl:1}
sed -i 's/\$LDFLAGS << " -lv8 "/\$LDFLAGS << " -l:libv8\.\so\.%{scl_v8}-3\.14\.5 "/' ext/v8/build.rb
sed -i '16i$LDFLAGS << " -L/opt/rh/%{scl_v8}/root/usr/lib64 "' ext/v8/build.rb
sed -i '16i$INCFLAGS << " -I/opt/rh/%{scl_v8}/root/usr/include "' ext/v8/build.rb
sed -i "s/find_header('v8.h')/find_header('v8.h','\/opt\/rh\/%{scl_v8}\/root\/usr\/lib64')/" ext/v8/build.rb
%endif

%{?scl:EOF}

%build
mkdir -p .%{gem_dir}
CONFIGURE_ARGS="--with-cflags='%{optflags}' $CONFIGURE_ARGS"

%{?scl:scl enable %{scl} %{scl_v8} - << \EOF}
# Be carefull, which .gemspec is taken!
gem build ../%{gem_name}.gemspec

gem install \
        -V \
        --local \
        --install-dir .%{gem_dir} \
        --bindir .%{_bindir} \
        --force \
        --document=ri,rdoc \
        --verbose \
        %{gem_name}-%{version}%{?preminorver}.gem \
        # This causes problems because of writing build info file
        #-- \
        #--with-v8-include=/opt/rh/v8314/root/usr/include \
        #--with-v8-lib=/opt/rh/v8314/root/usr/lib64
%{?scl:EOF}


%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* \
        %{buildroot}%{gem_dir}/

# Remove the binary extension sources and build leftovers.
rm -rf %{buildroot}%{gem_instdir}/ext

# remove shebang in non-executable file
sed -i '1d' %{buildroot}%{gem_instdir}/Rakefile

# Install macros
%if 0%{?scl:1}
mkdir -p %{buildroot}%{_root_sysconfdir}/rpm
install -m 644 %{SOURCE1} %{buildroot}%{_root_sysconfdir}/rpm/macros.%{gem_name}%{?scl:.%{scl}}
%endif

# Create therubyracer.rb to satisfy requires
cat <<"EOF" > %{buildroot}%{gem_instdir}/lib/therubyracer.rb
require 'v8'
EOF

%files
%dir %{gem_instdir}
%doc %{gem_instdir}/README.md
%{gem_libdir}
%exclude %{gem_cache}
%exclude %{gem_instdir}/.*
%{gem_spec}

%if 0%{?scl:1}
%config(noreplace) %{_root_sysconfdir}/rpm/macros.%{gem_name}%{?scl:.%{scl}}
%endif

%files doc
%doc %{gem_docdir}
%doc %{gem_instdir}/Changelog.md
%{gem_instdir}/benchmarks.rb
%{gem_instdir}/Gemfile
%{gem_instdir}/Rakefile
%{gem_instdir}/spec
%{gem_instdir}/thefrontside.png
%{gem_instdir}/therubyracer.gemspec

%changelog
* Mon Apr 20 2015 Joe VLcek <jvlcek@redhat.com> - 0.11.0-5
- Leave arch dependent files where gem install put them.

* Wed Apr 08 2015 Joe VLcek <jvlcek@redhat.com> - 0.11.0-3
- Initial package from cfme

* Tue Apr 07 2015 Joe VLcek <jvlcek@redhat.com> - 0.12.1-2
- Add Require for libv8

* Thu Apr 02 2015 Joe VLcek <jvlcek@redhat.com> - 0.12.1-1
- Build newer version 0.12.1

* Thu Mar 20 2014 Josef Stribny <jstribny@redhat.com> - 0.11.0-0.9.beta5
- Depend on scldevel(v8) virtual provide
  - Resolves: rhbz#1070332

* Mon Feb 17 2014 Josef Stribny <jstribny@redhat.com> - 0.11.0-0.8.beta5
- Don't install v8 scl macros, they should come in v8 scldevel subpackage
  - Resolves: rhbz#1065887

* Thu Nov 28 2013 Vít Ondruch <vondruch@redhat.com> - 0.11.0-0.7.beta5
- Depend on v8 scl.

* Thu Aug 01 2013 Tomas Hrcka <thrcka@redhat.com> - 0.11.0-0.6.beta5
- rebuild against new v8

* Thu May 02 2013 Vít Ondruch <vondruch@redhat.com> - 0.11.0-0.5.beta5
- Fix compatibility with v8-3.14.5.8.

* Thu Jul 26 2012 Bohuslav Kabrda <bkabrda@redhat.com> - 0.11.0-0.4.beta5
- Rebuilt for SCL.

* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.11.0-0.3.beta5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Mon Jul 16 2012 Bohuslav Kabrda <bkabrda@redhat.com> - 0.11.0-0.2.beta5
- Fixed minor issues according to review comments (RHBZ #838870).

* Fri Jun 15 2012 Bohuslav Kabrda <bkabrda@redhat.com> - 0.11.0-0.1.beta5
- Initial package
